run_intro		halt
				xor a
				call attr_fill_s

				ld hl,#4000
				ld de,#4001
				ld bc,#17FF
				ld (hl),l
				ldir

				ld a,%01000111
				call attr_fill_s

				ld a,1
				ld (play_music),a

				;;;;

run_intro_0		halt
				call pf_tick

run_intro_1		ld hl,1024-16
				dec hl
				ld a,h
				or l
				jp z,run_intro_3

				ld (run_intro_1+1),hl

run_intro_2		ld de,pf_time_data
				ld a,(de)
				cp l
				jp nz,run_intro_0

				inc de
				ld a,(de)
				cp h
				jp nz,run_intro_0

				inc de
				ld (run_intro_2+1),de

				ld a,(pf_tick_cnt)
				inc a
				ld (pf_tick_cnt),a

				jp run_intro_0

				;;;;

run_intro_3		ld a,7
				call attr_fill

				ld b,15-1
run_intro_4		halt
				djnz run_intro_4

				;;;;

				ld hl,#4000
				ld de,#4001
				ld bc,#17FF
				ld (hl),l
				ldir

				halt
				xor a
				call attr_fill

				ld a,7 : call swap
				ld hl,#4000
				ld de,#C000
				ld bc,#1B00
				ldir

				;;;;

				ld a,5+8
				call swap

loop			ld hl,spn_data

				ld a,(bank)
				push af				; (1)
				and 8 : or (hl)
				call swap

				inc hl
				ld c,(hl)
				inc hl

				ld a,(hl)
				inc a
				jp nz,loop_0

				ld hl,spn_data

loop_0			ld (loop+1),hl

				ld de,chunks_buf
				ld h,c : ld l,e

				dup #400
				ldi
				edup

				pop af				; (2)
				call swap

				call chunks_blit
				halt
				call attr_fill_chunks

				ld a,#00
loop_nx_text	equ $-1

				and a
				jp nz,loop_1

				call tx_next
				xor a : ld (beat_cnt),a
				ld a,2 : ld (pssh_cnt),a : ld (loop_nx_text),a

loop_1			ld a,(beat_cnt) : ld b,a
				ld a,(tx_scr) : add a,b : ld (tx_scr),a
				ld a,(tx_attr) : add a,b : ld (tx_attr),a
				xor a : ld (beat_cnt),a

				call tx_print

				halt
				ld a,(bank)
				xor 8+2
				call swap

				jp loop

;-----------------------------------------------------------------------------------------------------------------------

on_int			ret

;-----------------------------------------------------------------------------------------------------------------------

on_note			ld a,(ix-12+CHP.SamNumX2)
				cp 3*2 : jp z,on_note_0
				cp 2*2 : jp z,on_note_1
				xor a : ret

on_note_0		ld a,#00
pssh_cnt		equ $-1

				dec a
				ld (pssh_cnt),a
				jp nz,on_note_2

				ld (loop_nx_text),a

on_note_2		ld a,(beat_cnt)
				dec a
				ld (beat_cnt),a

				xor a : ret

on_note_1		ld a,#00
beat_cnt		equ $-1

				inc a
				ld (beat_cnt),a

				xor a : ret

;-----------------------------------------------------------------------------------------------------------------------

attr_fill_chunks
				di
				ld (attr_fill_chunks_0+1),sp
				ld sp,#D800+(32*20)

				ld hl,#4343

				dup 16*16
				push hl
				edup

attr_fill_chunks_0
				ld sp,#0000
				ei
				ret
